︠5cca0e38-4b9a-4dac-b4a9-8310d93fbc36is︠
%md
## Some of [Introduction to QuTiP](http://nbviewer.ipython.org/github/jrjohansson/qutip-lectures/blob/master/Lecture-0-Introduction-to-QuTiP.ipynb)...
︡c7a89fbd-6465-4664-bb81-a179bf422362︡{"md":"## Some of [Introduction to QuTiP](http://nbviewer.ipython.org/github/jrjohansson/qutip-lectures/blob/master/Lecture-0-Introduction-to-QuTiP.ipynb)...\n"}︡
︠74ac6d61-4ac7-4379-aff4-acea74a7f81es︠
from qutip import *
RealNumber = float; Integer = int
︡f7c2ccd9-c40b-4407-a8c2-6c8ea291ee55︡
︠633271e9-701c-4a1f-94f5-f20b6cd819a5s︠
q = Qobj([[1], [0]])
q
︡3311f6c5-1be1-45af-96ec-fdc9133b3999︡{"stdout":"Quantum object: dims = [[2], [1]], shape = [2, 1], type = ket\nQobj data =\n[[ 1.]\n [ 0.]]\n"}︡
︠56fc95ab-92de-4b0a-894f-31d9bfc78268s︠
# the dimension, or composite Hilbert state space structure
q.dims
︡2b167f49-d32f-4831-b2a7-7c8928b1c967︡{"stdout":"[[2], [1]]\n"}︡
︠f8de57bb-c35f-408c-a4fa-c6812ebfbb32s︠
# the shape of the matrix data representation
q.shape
︡45d4c75d-ac8c-48db-a1bd-2a14a3163d56︡{"stdout":"[2, 1]\n"}︡
︠54bc2c1e-85c6-4dba-abd9-eb7464b27f40s︠
# the matrix data itself. in sparse matrix format.
q.data
︡8da5a7bf-8480-43d8-8dc8-e99706afb208︡{"stdout":"<2x1 sparse matrix of type '<type 'numpy.complex128'>'\n\twith 1 stored elements in Compressed Sparse Row format>\n"}︡
︠158b2f19-c938-42a4-a9ec-32f70b860d7es︠
# get the dense matrix representation
q.full()
︡611fd5b9-8cb1-41cf-961a-30aeb4d9f2c6︡{"stdout":"array([[ 1.+0.j],\n       [ 0.+0.j]])\n"}︡
︠fdaa6bb7-f8eb-4eba-8e24-2b6afa6af745s︠
# some additional properties
q.isherm, q.type
︡39ae92ab-4382-4864-b213-12fbc8285903︡{"stdout":"(False, 'ket')\n"}︡
︠46374237-6411-4910-b80f-de9f675cff6cs︠
sy = Qobj([[0,-1j], [1j,0]])  # the sigma-y Pauli operator

sy
︡c5331561-1925-4831-b245-f69a0966d99f︡{"stdout":"Quantum object: dims = [[2], [2]], shape = [2, 2], type = oper, isherm = True\nQobj data =\n[[ 0.+0.j  0.-1.j]\n [ 0.+1.j  0.+0.j]]\n"}︡
︠0681a31b-3fda-4acf-b21d-d8532cc6a917s︠
sz = Qobj([[1,0], [0,-1]]) # the sigma-z Pauli operator

sz
︡641101c4-06ee-4ee5-b9e1-4937925f4639︡{"stdout":"Quantum object: dims = [[2], [2]], shape = [2, 2], type = oper, isherm = True\nQobj data =\n[[ 1.  0.]\n [ 0. -1.]]\n"}︡
︠c46dc3d9-08b6-40f7-832e-e05baa497103s︠
# some arithmetic with quantum objects

H = 1.0 * sz + 0.1 * sy

print("Qubit Hamiltonian = \n")
H
︡235f21e8-bf5e-43d2-abd2-1d93947d8ebf︡{"stdout":"Qubit Hamiltonian = \n\n"}︡{"stdout":"Quantum object: dims = [[2], [2]], shape = [2, 2], type = oper, isherm = True\nQobj data =\n[[ 1.+0.j   0.-0.1j]\n [ 0.+0.1j -1.+0.j ]]\n"}︡
︠5812ce14-2ec9-417b-8974-166ce0ceea24s︠
# The hermitian conjugate
sy.dag()
︡5249a55c-5826-4a24-a282-62a02ea003d0︡{"stdout":"Quantum object: dims = [[2], [2]], shape = [2, 2], type = oper, isherm = True\nQobj data =\n[[ 0.+0.j  0.-1.j]\n [ 0.+1.j  0.+0.j]]\n"}︡
︠3a6df6c5-2884-42aa-ba10-2f7343eb5784s︠
# The trace
H.tr()
︡f535b848-f99d-4ea8-899b-155d66b75eec︡{"stdout":"0.0\n"}︡
︠24c7c8d3-8cc2-4f12-8909-484339f593c2s︠
# Eigen energies
H.eigenenergies()
︡f194b710-b94a-487c-845b-9937ed94f10f︡{"stdout":"array([-1.00498756,  1.00498756])"}︡{"stdout":"\n"}︡
︠b20eadac-95a6-4c86-a42d-31ff02026a4b︠









